// score: 100
#include <bits/stdc++.h>
using namespace std;
using LL=long long;
#define int LL
#define vc vector
#define pb push_back
#define pr pair
#define fi first
#define se second
#define sz(v) ((int)(v).size())
#define all(v) (v).begin(),(v).end()
#define f(i,n) for(int i=0;i<(n);i++)
#define fr(i,n) for(int i=(n);i--;)
#define fv(i,v) f(i,sz(v))
struct S{
	int i,j;
	S():i(0),j(0){}
	S(int i,int j):i(i),j(j){}
};
struct P{
	array<S,4> stones;
	template<class F>
	int forMoves(F doIt){
		bool occ[8][8]={0};
		for(auto &stone:stones){
			occ[stone.i][stone.j]=true;
		}
		for(auto &stone:stones){
			auto cstone=stone;
			f(l,4){
				int di=(l==0)-(l==1),dj=(l==2)-(l==3);
				int ni=cstone.i+di,nj=cstone.j+dj;
				if(ni<0||ni>=8||nj<0||nj>=8) continue;
				if(occ[ni][nj]) ni+=di, nj+=dj;
				if(ni<0||ni>=8||nj<0||nj>=8) continue;
				if(occ[ni][nj]) continue;
				stone={ni,nj};
				if(auto r=doIt(*this)){
					stone=cstone;
					return r;
				}
			}
			stone=cstone;
		}
		return 0;
	}
	uint64_t hash(){
		uint64_t r=0;
		for(auto &stone:stones)
			r|=(uint64_t)1<<(8*stone.i+stone.j);
		return r;
	}
};

unordered_map<uint64_t,int> v;
bool dfs(P &x,int c,int depth){
	auto xhash=x.hash();
	if(v.count(xhash)){
		int vx=v[xhash];
		if((vx&1)!=c) return true;
		if((vx>>1)>=depth) return false;
	}
	v[xhash]=2*depth+c;
	if(depth==0) return false;
	return x.forMoves([&](P &y){
		if(dfs(y,c,depth-1)) return true;
		return false;
	});
}

main(){
	ios::sync_with_stdio(0),cin.tie(0);
	P a,b;
	f(k,4){
		int i,j;
		cin>>i>>j;
		a.stones[k]=S{i-1,j-1};
	}
	f(k,4){
		int i,j;
		cin>>i>>j;
		b.stones[k]=S{i-1,j-1};
	}
	auto r=dfs(a,0,4);
	assert(!r);
	cout<<(dfs(b,1,4)?"YES\n":"NO\n");
}
